| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Signals | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Tp::Client::ChannelTypeContactSearchInterface Class Reference
Client-side proxies » Channel proxies

`#include <TelepathyQt/Channel>`

Inheritance diagram for Tp::Client::ChannelTypeContactSearchInterface:
[legend]

## Public Slots

QDBusPendingReply | Search (const Tp::ContactSearchMap &terms, int timeout=-1)
QDBusPendingReply | More (int timeout=-1)
QDBusPendingReply | Stop (int timeout=-1)

## Signals

void | SearchStateChanged (uint state, const QString &error, const QVariantMap &details)
void | SearchResultReceived (const Tp::ContactSearchResultMap &result)
Signals inherited from Tp::AbstractInterface
void | propertiesChanged (const QVariantMap &changedProperties, const QStringList &invalidatedProperties)

## Public Member Functions

| ChannelTypeContactSearchInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
| ChannelTypeContactSearchInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
| ChannelTypeContactSearchInterface (Tp::DBusProxy *proxy)
| ChannelTypeContactSearchInterface (const Tp::Client::ChannelInterface &mainInterface)
| ChannelTypeContactSearchInterface (const Tp::Client::ChannelInterface &mainInterface, QObject *parent)
Tp::PendingVariant * | requestPropertySearchState () const
Tp::PendingVariant * | requestPropertyLimit () const
Tp::PendingVariant * | requestPropertyAvailableSearchKeys () const
Tp::PendingVariant * | requestPropertyServer () const
Tp::PendingVariantMap * | requestAllProperties () const
Public Member Functions inherited from Tp::AbstractInterface
virtual | ~AbstractInterface ()
bool | isValid () const
QString | invalidationReason () const
QString | invalidationMessage () const
void | setMonitorProperties (bool monitorProperties)
bool | isMonitoringProperties () const
Public Member Functions inherited from QDBusAbstractInterface
virtual | ~QDBusAbstractInterface ()
bool | isValid () const
QDBusConnection | connection () const
QString | service () const
QString | path () const
QString | interface () const
QDBusError | lastError () const
void | setTimeout (int timeout)
int | timeout () const
QDBusMessage | call (const QString &method, const QVariant &arg1, const QVariant &arg2, const QVariant &arg3, const QVariant &arg4, const QVariant &arg5, const QVariant &arg6, const QVariant &arg7, const QVariant &arg8)
QDBusMessage | call (QDBus::CallMode mode, const QString &method, const QVariant &arg1, const QVariant &arg2, const QVariant &arg3, const QVariant &arg4, const QVariant &arg5, const QVariant &arg6, const QVariant &arg7, const QVariant &arg8)
QDBusMessage | callWithArgumentList (QDBus::CallMode mode, const QString &method, const QList< QVariant > &args)
bool | callWithCallback (const QString &method, const QList< QVariant > &args, QObject *receiver, const char *returnMethod, const char *errorMethod)
bool | callWithCallback (const QString &method, const QList< QVariant > &args, QObject *receiver, const char *slot)
QDBusPendingCall | asyncCall (const QString &method, const QVariant &arg1, const QVariant &arg2, const QVariant &arg3, const QVariant &arg4, const QVariant &arg5, const QVariant &arg6, const QVariant &arg7, const QVariant &arg8)
QDBusPendingCall | asyncCallWithArgumentList (const QString &method, const QList< QVariant > &args)
Public Member Functions inherited from QObject
| QObject (QObject *parent)
virtual | ~QObject ()
virtual bool | event (QEvent *e)
virtual bool | eventFilter (QObject *watched, QEvent *event)
virtual const QMetaObject * | metaObject () const
QString | objectName () const
void | setObjectName (const QString &name)
bool | isWidgetType () const
bool | signalsBlocked () const
bool | blockSignals (bool block)
QThread * | thread () const
void | moveToThread (QThread *targetThread)
int | startTimer (int interval)
void | killTimer (int id)
T | findChild (const QString &name) const
QList< T > | findChildren (const QString &name) const
QList< T > | findChildren (const QRegExp &regExp) const
QObject * | child (const char *objName, const char *inheritsClass, bool recursiveSearch) const
const QObjectList & | children () const
void | setParent (QObject *parent)
void | installEventFilter (QObject *filterObj)
void | removeEventFilter (QObject *obj)
bool | connect (const QObject *sender, const char *signal, const char *method, Qt::ConnectionType type) const
bool | disconnect (const char *signal, const QObject *receiver, const char *method)
bool | disconnect (const QObject *receiver, const char *method)
void | dumpObjectTree ()
void | dumpObjectInfo ()
bool | setProperty (const char *name, const QVariant &value)
QVariant | property (const char *name) const
QList< QByteArray > | dynamicPropertyNames () const
void | destroyed (QObject *obj)
QObject * | parent () const
bool | inherits (const char *className) const
void | deleteLater ()
| QObject (QObject *parent, const char *name)
void | insertChild (QObject *object)
void | removeChild (QObject *object)
bool | isA (const char *className) const
const char * | className () const
const char * | name () const
const char * | name (const char *defaultName) const
void | setName (const char *name)

## Static Public Member Functions

static QLatin1String | staticInterfaceName ()
Static Public Member Functions inherited from QObject
QString | tr (const char *sourceText, const char *disambiguation, int n)
QString | trUtf8 (const char *sourceText, const char *disambiguation, int n)
bool | connect (const QObject *sender, const char *signal, const QObject *receiver, const char *method, Qt::ConnectionType type)
bool | connect (const QObject *sender, const QMetaMethod &signal, const QObject *receiver, const QMetaMethod &method, Qt::ConnectionType type)
bool | disconnect (const QObject *sender, const char *signal, const QObject *receiver, const char *method)
bool | disconnect (const QObject *sender, const QMetaMethod &signal, const QObject *receiver, const QMetaMethod &method)

## Protected Member Functions

virtual void | invalidate (Tp::DBusProxy *, const QString &, const QString &)
Protected Member Functions inherited from Tp::AbstractInterface
| AbstractInterface (DBusProxy *proxy, const QLatin1String &interface)
| AbstractInterface (const QString &busName, const QString &path, const QLatin1String &interface, const QDBusConnection &connection, QObject *parent)
PendingVariant * | internalRequestProperty (const QString &name) const
PendingOperation * | internalSetProperty (const QString &name, const QVariant &newValue)
PendingVariantMap * | internalRequestAllProperties () const
Protected Member Functions inherited from QObject
QObject * | sender () const
int | senderSignalIndex () const
int | receivers (const char *signal) const
virtual void | timerEvent (QTimerEvent *event)
virtual void | childEvent (QChildEvent *event)
virtual void | customEvent (QEvent *event)
virtual void | connectNotify (const char *signal)
virtual void | disconnectNotify (const char *signal)
bool | checkConnectArgs (const char *signal, const QObject *object, const char *method)

## Additional Inherited Members

Protected Slots inherited from Tp::AbstractInterface
Static Protected Member Functions inherited from QObject
QByteArray | normalizeSignalSlot (const char *signalSlot)
Properties inherited from QObject
| objectName

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Channel.Type.ContactSearch".

## Constructor & Destructor Documentation

## § ChannelTypeContactSearchInterface() [1/5]

Tp::Client::ChannelTypeContactSearchInterface::ChannelTypeContactSearchInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ChannelTypeContactSearchInterface associated with the given object on the session bus.

Parameters

  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

## § ChannelTypeContactSearchInterface() [2/5]

Tp::Client::ChannelTypeContactSearchInterface::ChannelTypeContactSearchInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ChannelTypeContactSearchInterface associated with the given object on the given bus.

Parameters

  connection | The bus via which the object can be reached.
  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

## § ChannelTypeContactSearchInterface() [3/5]

Tp::Client::ChannelTypeContactSearchInterface::ChannelTypeContactSearchInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a ChannelTypeContactSearchInterface associated with the same object as the given proxy.

Parameters

  proxy | The proxy to use. It will also be the QObject::parent() for this object.

## § ChannelTypeContactSearchInterface() [4/5]

Tp::Client::ChannelTypeContactSearchInterface::ChannelTypeContactSearchInterface | ( | const Tp::Client::ChannelInterface & | mainInterface | ) |

explicit

Creates a ChannelTypeContactSearchInterface associated with the same object as the given proxy. Additionally, the created proxy will have the same parent as the given proxy.

Parameters

  mainInterface | The proxy to use.

## § ChannelTypeContactSearchInterface() [5/5]

Tp::Client::ChannelTypeContactSearchInterface::ChannelTypeContactSearchInterface | ( | const Tp::Client::ChannelInterface & | mainInterface,
|  | QObject * | parent
| ) |  |

Creates a ChannelTypeContactSearchInterface associated with the same object as the given proxy. However, a different parent object can be specified.

Parameters

  mainInterface | The proxy to use.
  parent | Passed to the parent class constructor.

## Member Function Documentation

## § staticInterfaceName()

static QLatin1String Tp::Client::ChannelTypeContactSearchInterface::staticInterfaceName | ( |  | ) |

inline static

Returns the name of the interface "org.freedesktop.Telepathy.Channel.Type.ContactSearch", which this class represents.

Returns
  The D-Bus interface name.

## § requestPropertySearchState()

Tp::PendingVariant* Tp::Client::ChannelTypeContactSearchInterface::requestPropertySearchState | ( |  | ) | const

inline

Asynchronous getter for the remote object property `SearchState` of type `uint`.

The current state of this search channel object. Change notification is via SearchStateChanged.

Returns
  A pending variant which will emit finished when the property has been retrieved.

## § requestPropertyLimit()

Tp::PendingVariant* Tp::Client::ChannelTypeContactSearchInterface::requestPropertyLimit | ( |  | ) | const

inline

Asynchronous getter for the remote object property `Limit` of type `uint`.

If supported by the protocol, the maximum number of results that should be returned, where `0` represents no limit. If the protocol does not support limiting results, this should be `0`.

For example, if the terms passed to Search() match Antonius, Bridget and Charles and this property is `2`, the search service SHOULD only return Antonius and Bridget.

This property SHOULD be requestable if and only if the protocol supports specifying a limit; implementations SHOULD use `0` as the default if possible, or a protocol-specific sensible default otherwise.

Returns
  A pending variant which will emit finished when the property has been retrieved.

## § requestPropertyAvailableSearchKeys()

Tp::PendingVariant* Tp::Client::ChannelTypeContactSearchInterface::requestPropertyAvailableSearchKeys | ( |  | ) | const

inline

Asynchronous getter for the remote object property `AvailableSearchKeys` of type `QStringList`.

The set of search keys supported by this channel. Example values include [""] (for protocols where several address fields are implicitly searched) or ["x-n-given", "x-n-family", "nickname", "email"] (for XMPP XEP-0055, without extensibility via Data Forms). It can be in the NewChannels signal for round-trip reduction.

Returns
  A pending variant which will emit finished when the property has been retrieved.

## § requestPropertyServer()

Tp::PendingVariant* Tp::Client::ChannelTypeContactSearchInterface::requestPropertyServer | ( |  | ) | const

inline

Asynchronous getter for the remote object property `Server` of type `QString`.

For protocols which support searching for contacts on multiple servers with different DNS names (like XMPP), the DNS name of the server being searched by this channel, e.g. "characters.shakespeare.lit". Otherwise, the empty string. XEP 0055 defines a mechanism for XMPP clients to search services of their choice for contacts, such as users.jabber.org (the "Jabber User Directory"). This property SHOULD be requestable if and only if the protocol supports querying multiple different servers; implementations SHOULD use a sensible default if possible if this property is not specified in a channel request. This allows a client to perform searches on a protocol it knows nothing about without requiring the user to guess a valid server's hostname.

Returns
  A pending variant which will emit finished when the property has been retrieved.

## § requestAllProperties()

Tp::PendingVariantMap* Tp::Client::ChannelTypeContactSearchInterface::requestAllProperties | ( |  | ) | const

inline

Request all of the DBus properties on the interface.

Returns
  A pending variant map which will emit finished when the properties have been retrieved.

## § Search

QDBusPendingReply Tp::Client::ChannelTypeContactSearchInterface::Search | ( | const Tp::ContactSearchMap & | terms,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `Search` on the remote object.

Send a request to start a search for contacts on this connection. This may only be called while the SearchState is Not_Started; a valid search request will cause the SearchStateChanged signal to be emitted with the state In_Progress.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  terms

      A dictionary mapping search key names to the desired values

  timeout | The timeout in milliseconds.

## § More

QDBusPendingReply Tp::Client::ChannelTypeContactSearchInterface::More | ( | int | timeout = `-1` | ) |

inline slot

Begins a call to the D-Bus method `More` on the remote object.

Request that a search in SearchState `More_Available` move back to state `In_Progress` and continue listing up to Limit more results.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  timeout | The timeout in milliseconds.

## § Stop

QDBusPendingReply Tp::Client::ChannelTypeContactSearchInterface::Stop | ( | int | timeout = `-1` | ) |

inline slot

Begins a call to the D-Bus method `Stop` on the remote object.

Stop the current search. This may not be called while the SearchState is Not_Started. If called while the SearchState is In_Progress, SearchStateChanged() will be emitted, with the state Failed and the error `org.freedesktop.Telepathy.Error.Cancelled`.

Calling this method on a search in state Completed or Failed succeeds, but has no effect.

Specifying Stop to succeed when the search has finished means that clients who call Stop just before receiving SearchStateChanged() don't have to handle a useless error.

Depending on the protocol, the connection manager may not be able to prevent the server from sending further results after this method returns; if this is the case, it MUST ignore any further results.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  timeout | The timeout in milliseconds.

## § SearchStateChanged

void Tp::Client::ChannelTypeContactSearchInterface::SearchStateChanged | ( | uint | state,
|  | const QString & | error,
|  | const QVariantMap & | details
| ) |  |

signal

Represents the signal `SearchStateChanged` on the remote object.

Emitted when the SearchState property changes. The implementation MUST NOT make transitions other than the following:

- `Not_Started` → `In_Progress`
- `In_Progress` → `More_Available`
- `More_Available` → `In_Progress`
- `In_Progress` → `Completed`
- `In_Progress` → `Failed`

Parameters

  state

      The new search state

  error | If the new state is `Failed`, the name of a D-Bus error describing what went wrong. Otherwise, the empty string.

  details

  Additional information about the state transition, which may include the following well-known keys:
  debug-message (s)
    Debugging information on the change, corresponding to the message part of a D-Bus error message, which SHOULD NOT be displayed to users under normal circumstances

  This argument allows for future extensions. For instance, if moving to state `Failed` because the server rejected one of our search terms, we could define a key that indicates which terms were invalid.

## § SearchResultReceived

void Tp::Client::ChannelTypeContactSearchInterface::SearchResultReceived | ( | const Tp::ContactSearchResultMap & | result | ) |

signal

Represents the signal `SearchResultReceived` on the remote object.

Emitted when a some search results are received from the server. This signal can be fired arbitrarily many times so clients MUST NOT assume they'll get only one signal.

Parameters

  result

      A mapping from contact identifier to an array of fields
      representing information about this contact.

## § invalidate()

void Tp::Client::ChannelTypeContactSearchInterface::invalidate | ( | Tp::DBusProxy * | proxy,
|  | const QString & | error,
|  | const QString & | message
| ) |  |

protected virtual

Reimplemented from Tp::AbstractInterface.